module PCMTOPWM (CYC_CLK1_12, AUDIO_R,AUDIO_L,RX, KEY, LEDR);

input           CYC_CLK1_12;
inout           AUDIO_R;
inout           AUDIO_L;
inout           RX;
input           KEY;
output  [7:0]   LEDR;

wire            sys_clk;
wire            sys_rst_n = KEY;

reg             pwm_out_ff;
reg     [7:0]   pwm_cnt_ff;
reg     [7:0]   pcm_sample_ff;
wire    [7:0]   uart_dat;

mypll pll_inst(.inclk0 (CYC_CLK1_12),
                .c0 (sys_clk),          // 255 MHz clock
                .locked (LEDR[0])
                );

simple_uart_receiver uart_rec(.i_clk (sys_clk), 
                                .i_rst_n (sys_rst_n), 
                                .i_rx (RX), 
                                .o_dat (uart_dat), 
                                .o_dat_vld ()
                                );

always @(posedge sys_clk)
    pcm_sample_ff <= uart_dat;

always @(posedge sys_clk)
    pwm_cnt_ff <= pwm_cnt_ff + 1'b1;

always @(posedge sys_clk)
    pwm_out_ff <= (pwm_cnt_ff < pcm_sample_ff);

assign AUDIO_R = pwm_out_ff;
assign AUDIO_L = pwm_out_ff;

endmodule